/*
 * See qemu/target/arm/translate-a64.c:disas_exc()
 */

#define HALT_GROUP  (10 << 25)
#define HALT_GROUP2 ( 6 << 29)
#define HALT_OPC2(opc2)   ((opc2)  <<  2)
#define HALT_LL(ll)       ((ll)    <<  0)
#define HALT_OPC(opc)     ((opc)   << 21)
#define HALT_IMM16(imm16) ((imm16) <<  5)

#define CALL_ExcpnGen(opc, opc2, ll, imm16) \
	.long (HALT_GROUP | HALT_GROUP2 | HALT_OPC2(opc2) | HALT_LL(ll) | \
	HALT_OPC(opc) | HALT_IMM16(imm16))

#define CALL_BRK      CALL_ExcpnGen(1, 0, 0, 0)
#define CALL_SEMIHOST CALL_ExcpnGen(2, 0, 0, 0xf000)
#define CALL_SWI(arg) CALL_ExcpnGen(0, 0, 1, (arg));

/*
 * for semihosting call on QEMU
 */

#define SEMIHOSTING_SYSTEM 0x12
#define SEMIHOSTING_EXIT   0x18

#define PUSH_REGS \
	sub	sp, sp, #32 ; \
	str	x3, [sp, #24] ; \
	str	x2, [sp, #16] ; \
	str	x1, [sp, #8] ; \
	str	x0, [sp]
#define POP_REGS \
	ldr	x3, [sp, #24] ; \
	ldr	x2, [sp, #16] ; \
	ldr	x1, [sp, #8] ; \
	add	sp, sp, #32

#if 0
	.org	0x800006f0
#else
	.org	0x000006f0
#endif

	.section .text

	.globl	_start
	.type	_start, %function
_start:
_command:	.string	"sh"
	.byte	0
	.long	0
	.long	0
	.long	0

	.quad	(1f + 0x80000000)	/* return address from main() */

1:	sub	sp, sp, #0x110	/* stack frame of main() */
	sub	sp, sp, #0x10	/* buffer in proc() */

	ldr	x0, _command_addr
	orr	x0, x0, #0x80000000

	.globl	__semihosting_system
	.type	__semihosting_system, %function
__semihosting_system:
	PUSH_REGS
	mov	x1, sp
	mov	w0, #SEMIHOSTING_SYSTEM
	CALL_SEMIHOST

	mov	x0, #0

	.globl	__semihosting_exit
	.type	__semihosting_exit, %function
__semihosting_exit:
	PUSH_REGS
	mov	x1, sp
	mov	w0, #SEMIHOSTING_EXIT
	CALL_SEMIHOST

1:	b	1b

	.align 8
_command_addr:
	.quad	_command
